USERDATA unsigned char bcd[5];  //0: high  4: low

typedef union {
	unsigned long	q;
	unsigned char 	b[4];
} tq;

typedef union {
	unsigned int	d;
	unsigned char 	b[2];
} tw;

unsigned long Pow10[] PROGMEM = {
	1,
	10,
	100,
	1000,
	10000,
	100000,
	1000000,
	10000000,
	100000000,
	1000000000}; 

/*
void f2bcd(tq f)  REWRITABLE; //conversion f[MHz]=>BCD
void f2bcd(tq f){
tw w;
unsigned char b;
unsigned char i;	
w.b[0]=f.b[2];			//integer MHz digits
w.b[1]=f.b[3];
w.d=w.d>>5;
b=0;
while (w.d>=1000){
  w.d=w.d-1000;
  b++;
  }
bcd[0]=b<<4;
b=0;
while (w.d>=100){
  w.d=w.d-100;
  b++;
  }
bcd[0]=bcd[0] | b;
b=0;
while (w.d>=10){
  w.d=w.d-10;
  b++;
  }
bcd[1]=(b<<4) | w.b[0];
f.q=f.q<<3;				//fractional MHz digits
f.b[3]=0;
for (i=2;i<=4;i++){
  f.b[3]=0;
  f.q=f.q*10;
  b=f.b[3]<<4;
  f.b[3]=0;
  f.q=f.q*10;
  bcd[i]=f.b[3]|b;
  }
}


unsigned long bcd2fs(void)  REWRITABLE; 	//conversion bcd to f[Hz] 
unsigned long bcd2fs(void){					//requires about 5000 cycles
unsigned long fs,adder;
unsigned char i,j;
fs=0;
j=0;
adder=1;
for (i=0;i<=4;i++)
	{
	fs=fs+(bcd[i] & 0xF)*adder;
	adder=adder*10;
	fs=fs+((bcd[i] & 0xF0)>>4)*adder;
	adder=adder*10;
	}
return fs;	
}
*/

void long2bcd(unsigned long x) REWRITABLE;	//conversion f[Hz] to BCD
void long2bcd(unsigned long x){  			//about 1000 cycles
unsigned char i,d;
unsigned long y;
unsigned char j=9;
for (i=0;i<5;i++)
  {
  d=0;
  y=pgm_read_dword(&Pow10[j]);  
  while (x>=y)
    {
	x=x-y;
	d++;
	}
  bcd[i]=d<<4;
  j--;
  d=0;
  y=pgm_read_dword(&Pow10[j]);
  while (x>=y)
	{
	x=x-y;
	d++;
	}
  bcd[i]=bcd[i] | d;
  j--;
  }
}

/*
char char2bcd(char x) REWRITABLE; //2 digit data conversion 4 bit binary to bcd
char char2bcd(char x) {
if (x<10) return x;
return x+6;
}
*/

char char2bcd(char x) REWRITABLE; //2 digit data conversion binary to bcd
char char2bcd(char x) {
char r;
for (r=0;r<=0x90;r+=0x10)
{
if (x<10)
  {
   r=r+x;
   return r;
  }
x=x-10;
}
return -1;
}
